Page MenuHomePhabricator

Create documentation on how to implement a custom Herald action
Closed, WontfixPublic

Description

I am currently trying to exend Herald with new Actions. I was able to put the actions up for selection, but they are not listed in transactions.

An example / how-to / documentation on how to extend Herald (programmatically) would be much appreciated.

Event Timeline

ite-klass updated the task description. (Show Details)May 27 2014, 11:37 AM
ite-klass added a project: Herald.
ite-klass added a subscriber: ite-klass.
ite-klass created this task.
ite-klass raised the priority of this task from to Needs Triage.

This isn't expected to work until D8784 lands.

chad triaged this task as Low priority.
20after4 claimed this task.Jul 11 2014, 5:34 AM

see @epriestley's exceedingly helpful reply to T5571 for a starting point. I will try to expand on that and make it into something a bit more general for documentation purposes.

Any update on this? @20after4 are you still working on this?

feifan added a subscriber: feifan.Jun 11 2015, 7:16 PM
epriestley closed this task as Wontfix.Aug 3 2015, 8:11 PM

This has been in the update notes for a while, but just for completeness: T8726 is changing this substantially. After those change land, you must extend HeraldAction instead of HeraldCustomAction. The API is similar, but doesn't directly map to the old class.

All upstream actions have been converted to be modular subclasses of HeraldAction, so you can look at them for examples. The actual meat of your actions is likely unchanged (or mostly unchanged -- logging/UI is a little more fleshed out now), but how you get data about them is much different.

Since the upstream is now modularized, I'm not specifically going to pursue any documentation here until after we formally support third-party development (see T5447): this will now be on par with everything else and have some level of "documentation" in the form of a bunch of examples, at least.

urzds added a subscriber: urzds.Jul 12 2017, 11:15 AM